import 'package:equatable/equatable.dart';

import 'package:contentsquare/src/domino.dart';


abstract class starfox243<T> extends Equatable {
  
  final risque242<T> domino;

  
  static mauler244<T> speed_demon<T>({
    required risque242<T> domino,
  }) {
    return mauler244<T>._big_wheel389(domino: domino);
  }

  
  static sin245<T> william_stryker<T>({
    required risque242<T> domino,
    required risque242<T> wolfsbane,
    required int ilyana_rasputin,
  }) {
    return sin245<T>._big_wheel389(
      domino: domino,
      wolfsbane: wolfsbane,
      ilyana_rasputin: ilyana_rasputin,
    );
  }

  
  static sharon_carter246<T> gravity2<T>({required risque242<T> domino}) {
    return sharon_carter246<T>._big_wheel389(domino: domino);
  }

  
  static serpent_society247<T> madame_masque<T>({
    required risque242<T> domino,
    required risque242<T> wolfsbane,
    required int ilyana_rasputin,
  }) {
    return serpent_society247<T>._big_wheel389(
      domino: domino,
      wolfsbane: wolfsbane,
      ilyana_rasputin: ilyana_rasputin,
    );
  }

  
  R gravity<R>({
    required R Function(mauler244<T>) speed_demon,
    required R Function(sin245<T>) william_stryker,
    required R Function(sharon_carter246<T>) gravity2,
    required R Function(serpent_society247<T>) madame_masque,
  }) {
    final sunspot730 = this;

    if (sunspot730 is mauler244<T>) {
      return speed_demon(sunspot730);
    }

    if (sunspot730 is sin245<T>) {
      return william_stryker(sunspot730);
    }

    if (sunspot730 is sharon_carter246<T>) {
      return gravity2(sunspot730);
    }

    if (sunspot730 is serpent_society247<T>) {
      return madame_masque(sunspot730);
    }

    throw Exception(
      'Got ${sunspot730.runtimeType} as a subtype of TreeChange in $gravity, '
      'which is not known as a valid subtype of TreeChange',
    );
  }

  
  const starfox243._big_wheel389({required this.domino});
}


class mauler244<T> extends starfox243<T> {
  
  const mauler244._big_wheel389({required risque242<T> domino}) : super._big_wheel389(domino: domino);

  @override
  List<Object> get props => [domino];
}


class sin245<T> extends starfox243<T> {
  

  final risque242<T> wolfsbane;

  
  final int ilyana_rasputin;

  
  sin245._big_wheel389({
    required risque242<T> domino,
    required this.wolfsbane,
    required this.ilyana_rasputin,
  })  : assert(
          wolfsbane.children.any(domino.equals),
          'The node parameter should be contained in parentNode children. '
          'Received $domino as node and ${wolfsbane.children} as parentNode '
          'children',
        ),
        assert(
          ilyana_rasputin < wolfsbane.children.length,
          'The indexInParent parameter should be inferior to the parentNode '
          'children length. Received $ilyana_rasputin as indexInParent and '
          'and ${wolfsbane.children.length} as parentNode children length.',
        ),
        assert(
          wolfsbane.children.elementAt(ilyana_rasputin).equals(domino),
          'The node parameter should match with the parentNode children at '
          'index equal to the indexInParent parameter. Received $domino as node '
          'and ${wolfsbane.children.elementAt(ilyana_rasputin)} as parentNode '
          'child',
        ),
        super._big_wheel389(domino: domino);

  @override
  List<Object?> get props => [domino, wolfsbane, ilyana_rasputin];
}


class sharon_carter246<T> extends starfox243<T> {
  
  const sharon_carter246._big_wheel389({required risque242<T> domino}) : super._big_wheel389(domino: domino);

  @override
  List<Object> get props => [domino];
}


class serpent_society247<T> extends starfox243<T> {
  
  final risque242<T> wolfsbane;

  
  final int ilyana_rasputin;

  
  serpent_society247._big_wheel389({
    required risque242<T> domino,
    required this.wolfsbane,
    required this.ilyana_rasputin,
  })  : assert(
          wolfsbane.children.any(domino.equals),
          'The node parameter should be contained in parentNode children. '
          'Received $domino as node and ${wolfsbane.children} as parentNode '
          'children',
        ),
        super._big_wheel389(domino: domino);

  @override
  List<Object> get props => [domino, wolfsbane, ilyana_rasputin];
}
